// component/tabSort/tabSort.js
var app = getApp()
const wxService = require('../../utils/wxService')
const utils = require('../../utils/util')
const utilLink = require('../../utils/currentLinkRouter')
const envInfo = require('../../config/index').envInfo
let defaultImg = 'https://img3.bigaka.com/prd/3001/202003/20200331/30019aa78220-546f-41e0-8075-c2feb69e10b8.jpg';
Component({
	/**
	 * 组件的属性列表
	 */
	properties: {
		currentHasUserInfo:{
      type: Boolean,
      type: false
    },
		categoryTab: {
			type: Object,
			value: null
		},
		currHomePageId: {
			type: String,
			value: ''
		},
		categoryTabFixed : {
			type: Boolean,
      type: false
		}
	},
	observers:{
		categoryTabFixed(val){},
		categoryTab(val){
			console.log(this.data)
			
		}
	},
	attached() {
		// const { categoryTab } = this.data;
		let categoryTab = JSON.parse(JSON.stringify(this.data.categoryTab));
		let currentTab = categoryTab && categoryTab.categorys || []
		currentTab.forEach(item => {
			if(typeof item.row === 'string'){
				item.row = JSON.parse(item.row);
			}

			item.value = item.row ? item.row.url : '';
			item.rowType = item.row ? item.row.type : 11;
			item.actived = false;
		});
		
		if(currentTab.length != 0){
			this.data.currentCategoryTabId = currentTab[0].value;
			this.data.currentCategoryRowType = currentTab[0].rowType;
			currentTab[0].actived = true;
		}

		this.setData({
			currentCategoryTab : categoryTab,
		});
		//调用获取数据接口
		this.data.pageNo = 1;
		this.data.totalPage = 0;
		this.data.proData = [];
		this.getTagProducts();
	},
	/**
	 * 组件的初始数据
	 */
	data: {
		// currentTab: 0,
		currentCategoryTabId : '',
		currentCategoryRowType : 10,//默认10
		linkType : '',
		isAuthorization: false, // false 不显示 true 显示
    currentCategoryTab: {},
		proData : [],
		pageNo : 1,
		pageSize : 10,
		totalPage : 0,
	},
  /*组件所在页面的生命周期 */
  pageLifetimes: {
    show: function () {
      // 页面被展示
      this.setData({
        currentTab: 99
      })
    },
    hide: function () {
      // 页面被隐藏
      this.setData({
        currentTab: 99
      })
    },
  },

	/**
	 * 组件的方法列表
	 */
	methods: {
		//获取标签下的商品列表
		getTagProducts(e){
			//表示父组件触到底部了
			if(e == 'scrollBottom'){
				if(this.data.pageNo < this.data.totalPage){
					this.data.pageNo ++;
					//判断关联的是标签还是后端分类
					if(this.data.currentCategoryRowType == 10){
						//标签
						this.getTagProductList();
					}
					else{
						//分类
						this.getCategoryProducts();
					}
				}
				else{
					//没有更多数据了 需要通知父组件更新其他组件状态
					this.triggerEvent('loadProductComplete', 'nomore');
				}
			}
			else{
				this.data.pageNo = 1;
				this.data.totalPage = 0;
				//判断关联的是标签还是后端分类
				if(this.data.currentCategoryRowType == 10){
					//标签
					this.getTagProductList();
				}
				else{
					//标签
					this.getCategoryProducts();
				}
			}
		},
		//获取标签下的商品列表
		getTagProductList(){
			let pageNo = this.data.pageNo, pageSize = this.data.pageSize;
			let	url = `/sale/product/buyer/listPageByTagId?pageNo=${pageNo}&pageSize=${pageSize}`;
			wxService.post(url,{
				mallCategoryId : null,
				categoryId : null,
				tagId : this.data.currentCategoryTabId,
				state : 1,
			}).then(res => {
				if(res){
					let list = res.data.data.content ? res.data.data.content : [];
					this.data.totalPage = res.data.data.totalPages;
					list.forEach(item => {
            //营销标签类型 1固定样式 2左下角显示商品当前金额 3左下角显示指定数额
            item.indexUrl = item.indexUrl ? item.indexUrl : defaultImg;
            //处理商品身上的营销标签数据
            item.hasPromotionTag = item.markTagInfo ? true : false;
            let tagPrice = item.minSalePrice;
            if(item.hasPromotionTag){
              item.tagPic = item.markTagInfo.tagPicUrl;
              if(item.markTagInfo.tagType == 2){
                tagPrice = item.minSalePrice;
              }
              else{
                tagPrice = item.markTagInfo.assignPrice;
              }
              
              item.tagType = item.markTagInfo.tagType;
            }
            //判断价格是否大于1000了
            if(tagPrice/100 > 1000){
              tagPrice = parseFloat(tagPrice/10/10).toFixed(1);
            }
            else{
              tagPrice = parseFloat(tagPrice/10/10).toFixed(2);
            }
            item.tagPrice = tagPrice;
					});
					
					this.data.proData = this.data.proData.concat(list);
					this.setData({
						proData : this.data.proData
					});
				}
			})
		},
		//获取后端分类下的商品列表
		getCategoryProducts(){
			let pageNo = this.data.pageNo, pageSize = this.data.pageSize;
			let url = `/sale/product/buyer/listPageByCategoryId?pageNo=${pageNo}&pageSize=${pageSize}`;
			wxService.post(url, {
				mallCategoryId : null,
				categoryId : this.data.currentCategoryTabId,
				tagId : null,
				state : 1,
			}).then(res => {
				const { result, data } = res.data
				if (result == 0 && data.content) {
					wx.hideLoading()
					let list = this.data.pageNo == 1 ? [...data.content] : [...this.data.proData, ...data.content];
					list.forEach(item => {
						//营销标签类型 1固定样式 2左下角显示商品当前金额 3左下角显示指定数额
						item.indexUrl = item.indexUrl ? item.indexUrl : defaultImg;
						//处理商品身上的营销标签数据
						item.hasPromotionTag = item.markTagInfo ? true : false;
						let tagPrice = item.minSalePrice;
						if(item.hasPromotionTag){
							item.tagPic = item.markTagInfo.tagPicUrl;
							if(item.markTagInfo.tagType == 2){
								tagPrice = item.minSalePrice;
							}
							else{
								tagPrice = item.markTagInfo.assignPrice;
							}
							
							item.tagType = item.markTagInfo.tagType;
						}
						//判断价格是否大于1000了
						if(tagPrice/100 > 1000){
							tagPrice = parseFloat(tagPrice/10/10).toFixed(1);
						}
						else{
							tagPrice = parseFloat(tagPrice/10/10).toFixed(2);
						}
						item.tagPrice = tagPrice;
					});

					this.data.proData = this.data.proData.concat(list);
					this.data.totalPage = data.totalPages;
					this.setData({
						proData: this.data.proData,
					});
				}
			}).finally(() => {
				wx.hideLoading()
			})
		},
		//切换分类
		onTapChangeCategory(e){
			let index = e.currentTarget.dataset.index;
			let item = e.currentTarget.dataset.item;
			if(this.data.currentCategoryTabId == item.value){
				return ;
			}

			wx.showLoading({
				title: '加载中..',
			})

			this.data.currentCategoryTab.categorys.forEach(item => {
				item.actived = false;
				if(typeof item.row === 'string'){
					item.row = JSON.parse(item.row);
					item.rowType = item.row.type;
					item.value = item.row.url;
				}
			});

			this.data.currentCategoryTab.categorys[index].actived = true;
			this.data.currentCategoryTabId = this.data.currentCategoryTab.categorys[index].value;
			this.data.currentCategoryRowType = this.data.currentCategoryTab.categorys[index].rowType;

			this.setData({
				currentCategoryTab : this.data.currentCategoryTab
			});
			//调用获取数据接口
			this.data.pageNo = 1;
			this.data.totalPage = 0;
			this.data.proData = [];
			this.getTagProducts();

			// 切换分类了，是否需要把之前显示的布局显示出来
			this.triggerEvent('loadProductComplete', 'tabChange');
		},
	}
})
